<?php
/**
 * YjContactUs default controller
 * 
 */

jimport('joomla.application.component.controller');

class YjContactUSController extends JController
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct()
	{
		parent::__construct();
		// Register Extra tasks
		$this->registerTask( 'apply','save' );
		$this->registerTask( 'unpublish', 'publish' );
		$this->registerTask( 'orderdown', 'order' );
		$this->registerTask( 'orderup', 'order' );		
	}
	
	/**
	 * Method to display the view
	 *
	 * @access	public
	 */
	function display()
	{
		parent::display();
	}
	
	/**
	 * html  for add new departments
	 * @return void
	 */	
	function add(){
		//set model and view
		$model =& $this->getModel('yjcontactus');
		$view 	=& $this->getView( 'yjcontactus', '.html' );
		$view->setModel( $model, true );		
		//function to display
		$view->add();
	}
	
	/**
	 * save new form
	 * @return void
	 */	
	function save(){
		$model =& $this->getModel('yjcontactus');
		$msg = $model->save();
		
		if(JRequest::getVar('task') == 'apply'){
			$db	=& JFactory::getDBO();
			if($db->insertId()){
				$cid = $db->insertId();
			}else{
				$cid = JRequest::getVar( 'id' );			
			}
			$this->setRedirect('index.php?option=com_yjcontactus&task=edit&cid[]='.$cid);
		}else{
			$this->setRedirect('index.php?option=com_yjcontactus&view=yjcontactus',$msg);
		}
	}	
	
	/**
	 * edit form
	 *
	 */
	function edit() {
		$model 	=& $this->getModel( 'yjcontactus' );
		$view 	=& $this->getView( 'yjcontactus', '.html' );
		$view->setModel( $model, true );
		$view->edit();
	}	
	
	/**
	 * return to main component
	 *
	 */
	function cancel() {
		$this->setRedirect('index.php?option=com_yjcontactus&view=yjcontactus');
	}	
	
	/**
	 * publish or unpubish departments
	 *
	 */
	function publish() {
		$model =& $this->getModel( 'yjcontactus' );
		$task = JRequest::getCmd('task');
		if ($task == 'publish') {
			$model->publish(1);
		} elseif ($task == 'unpublish') {
			$model->publish(0);
		} 
		
		$this->setRedirect('index.php?option=com_yjcontactus&view=yjcontactus');
	}
	
	/**
	 * delete a department
	 * @return void
	 */	
	function remove(){
		$model =& $this->getModel('yjcontactus');
		$msg = $model->delete();
		
		$this->setRedirect('index.php?option=com_yjcontactus&view=yjcontactus',$msg);
	}
	
	/**
	 * Method order up(-1)/down(1) a form with one record
	 *
	 * $ordering = int current ordering value
	 * $uid		 = int moved category id
	 * $inc		 = int up(-1)/down(1)
	 *
	 * @access	public
	 * @return	boolean	True on success
	 */	
	function order(){
		global $mainframe;
		$model =& $this->getModel('yjcontactus');
		$msg = $model->order();		
		
		$limit		= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart	= $mainframe->getUserStateFromRequest('limitstart', 'limitstart', 0, 'int');

		$link = 'index.php?option=com_yjcontactus&view=yjcontactus&limitstart='.$limitstart.'&limit='.$limit;
		$this->setRedirect($link, $msg);			
		
		return true;		
	}
	
	/**
	 * Method to save new order a form 
	 *
	 * $ordering = int current ordering value
	 * $uid		 = int moved category id
	 * $inc		 = int up(-1)/down(1)
	 *
	 * @access	public
	 * @return	boolean	True on success
	 */	
	function saveorder(){
		global $mainframe;
		$model =& $this->getModel('yjcontactus');
		$msg = $model->saveorder();		
		
		$limit		= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart	= $mainframe->getUserStateFromRequest('limitstart', 'limitstart', 0, 'int');

		$link = 'index.php?option=com_yjcontactus&view=yjcontactus&limitstart='.$limitstart.'&limit='.$limit;
		$this->setRedirect($link, $msg);			
		
		return true;		
	}		

}
?>
