<?php
/**
 * Departments Controller for YjContactUS Component
 * 
 * @package    
 * @subpackage Components
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

/**
 * Departments Controller
 */
class YjContactUSControllerYjDepartments extends JController
{
	/**
	 * constructor (registers additional tasks to methods)
	 * @return void
	 */
	function __construct()
	{
		parent::__construct();
		// Register Extra tasks
		$this->registerTask( 'apply','save' );
		$this->registerTask( 'unpublish', 'publish' );
		$this->registerTask( 'orderdown', 'order' );
		$this->registerTask( 'orderup', 'order' );		
	}

	/**
	 * display 
	 * @return void
	 */
	function display(){
		JRequest::setVar( 'view', 'yjdepartments' );
		JRequest::setVar( 'layout', 'default'  );
		//JRequest::setVar('hidemainmenu', 1);

		parent::display();
	}
	
	/**
	 * html  for add new departments
	 * @return void
	 */	
	function add(){
		$view 	=& $this->getView( 'yjdepartments', '.html' );
		$view->add();
	}
	
	/**
	 * save new department
	 * @return void
	 */	
	function save(){
		$model =& $this->getModel('yjdepartments');
		$msg = $model->save();
		
		if(JRequest::getVar('task') == 'apply'){
			$db	=& JFactory::getDBO();
			if($db->insertId()){
				$cid = $db->insertId();
			}else{
				$cid = JRequest::getVar( 'id' );			
			}
			$this->setRedirect('index.php?option=com_yjcontactus&controller=yjdepartments&task=edit&cid[]='.$cid);
		}else{
			$this->setRedirect('index.php?option=com_yjcontactus&controller=yjdepartments&view=yjdepartments',$msg);
		}
	}
	
	/**
	 * delete a department
	 * @return void
	 */	
	function remove(){
		$model =& $this->getModel('yjdepartments');
		$msg = $model->delete();
		
		$this->setRedirect('index.php?option=com_yjcontactus&controller=yjdepartments&view=yjdepartments',$msg);
	}	
	
	/**
	 * return to main component
	 *
	 */
	function cancel() {
		$this->setRedirect('index.php?option=com_yjcontactus&controller=yjdepartments&view=yjdepartments');
	}	
	
	/**
	 * edit departments
	 *
	 */
	function edit() {
		$model 	=& $this->getModel( 'yjdepartments' );
		$view 	=& $this->getView( 'yjdepartments', '.html' );
		$view->setModel( $model, true );
		$view->edit();
	}
	
	/**
	 * publish or unpubish departments
	 *
	 */
	function publish() {
		$model =& $this->getModel( 'yjdepartments' );
		$task = JRequest::getCmd('task');
		if ($task == 'publish') {
			$model->publish(1);
		} elseif ($task == 'unpublish') {
			$model->publish(0);
		} 
		
		$this->setRedirect('index.php?option=com_yjcontactus&controller=yjdepartments&view=yjdepartments');
	}	
	
	/**
	 * Method order up(-1)/down(1) a department with one record
	 *
	 * $ordering = int current ordering value
	 * $uid		 = int moved category id
	 * $inc		 = int up(-1)/down(1)
	 *
	 * @access	public
	 * @return	boolean	True on success
	 */	
	function order(){
		global $mainframe;
		$model =& $this->getModel('yjdepartments');
		$msg = $model->order();		
		
		$limit		= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart	= $mainframe->getUserStateFromRequest('limitstart', 'limitstart', 0, 'int');

		$link = 'index.php?option=com_yjcontactus&controller=yjdepartments&view=yjdepartments&limitstart='.$limitstart.'&limit='.$limit;
		$this->setRedirect($link, $msg);			
		
		return true;		
	}
	
	/**
	 * Method to save new order a department 
	 *
	 * $ordering = int current ordering value
	 * $uid		 = int moved category id
	 * $inc		 = int up(-1)/down(1)
	 *
	 * @access	public
	 * @return	boolean	True on success
	 */	
	function saveorder(){
		global $mainframe;
		$model =& $this->getModel('yjdepartments');
		$msg = $model->saveorder();		
		
		$limit		= $mainframe->getUserStateFromRequest('global.list.limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
		$limitstart	= $mainframe->getUserStateFromRequest('limitstart', 'limitstart', 0, 'int');

		$link = 'index.php?option=com_yjcontactus&controller=yjdepartments&view=yjdepartments&limitstart='.$limitstart.'&limit='.$limit;
		$this->setRedirect($link, $msg);			
		
		return true;		
	}	
	
}
?>
