<?php
/**
 * Departments model for YjContactUS Component
 * 
 * @package     
 * @subpackage Components
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport( 'joomla.application.component.model' );

/**
 * Departments Model
 *
 * @package   
 * @subpackage Components
 */
class YjContactUSModelYjDepartments extends JModel
{
	/**
	 * data array
	 *
	 * @var array
	 */
	var $_data;

	/**
	 * Retrieves the departments data
	 * @return array Array of objects containing the data from the database
	 */
	function getitems(){ 
	
		global $mainframe, $option;
		$db 			=& JFactory::getDBO(); 
		$config 		= new JConfig();
		$task 			= JArrayHelper::getValue( $_REQUEST, 'task', '' ); 
		$context		= $option;	
		
		$filter_order		= $mainframe->getUserStateFromRequest( 'filter_order', 'filter_order', 'ordering', '' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( 'filter_order_Dir', 'filter_order_Dir', '', '' );	
		$limit 			= intval( $mainframe->getUserStateFromRequest( "global.list.limit", 'limit', $mainframe->getCfg('list_limit'), 'int' ) );
		$limitstart 	= intval( $mainframe->getUserStateFromRequest( "limitstart", 'limitstart', 0, 'int' ) );
		
		// build query 's order
		$orderby 	= ' ORDER BY '. $filter_order .' '. $filter_order_Dir;
		
		// Get the total number of records
		$query = 'SELECT COUNT(*)' .
				' FROM #__yj_contactus_departments';
		$db->setQuery($query);
		$total = $db->loadResult();
				
		require_once( JPATH_SITE.DS.'administrator'.DS.'includes'.DS.'pageNavigation.php' );
		$pageNav = new JPagination( $total, $limitstart, $limit );	
	
		// Get the total records
		$query = 'SELECT *' 
				.' FROM #__yj_contactus_departments'
				."\n {$orderby}";
		$db->setQuery($query,$limitstart, $limit);
		$items = $db->loadObjectList();	
		// table ordering
		$lists['order_Dir']	= $filter_order_Dir;
		$lists['order']		= $filter_order;		

		$return = array("items"=>$items,"pageNav"=>$pageNav,"lists"=>$lists);
		
		return $return;
	}
	
	/**
	 * save/edit new departments
	 *
	 * @return unknown_type
	 */
	function save() {
		global $mainframe;

		$row =& $this->getTable();
		$cid = JRequest::getVar( 'id', array(), '', 'array' );
		JArrayHelper::toInteger($cid, array());

		// is new or not
		$is_new = true;
		if ($cid[0] != 0) {
			$is_new = false;
			$row->load($cid);
		}else{
			$row->ordering = $row->getNextOrder();
		}

		if (!$row->bind( $_POST )) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			return false;
		}

		if (!$row->check()) {
			echo "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
			return false;
		}
		
		if (!$row->store()) {
			$msg = "<script> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
		}else{
			if($is_new === true){
				$msg = JText::_("SUCC ADDED");
			}else{
				$msg = JText::_("SUCC EDITED");
			}
		}

		return $msg;
	}	
	
	/**
	 * delete department
	 *
	 * @return unknown_type
	 */
	function delete() {
		$cid = JRequest::getVar( 'cid', array(), '', 'array' );
		JArrayHelper::toInteger($cid, array());
		
		if (count($cid) > 0) {
			$row =& $this->getTable();
			foreach ($cid as $id) {
				$row->delete($id);
			}
			$msg = JText::_("DEPARTMENT SUCC DELETED");
		} else {
			JError::raiseError(500, JText::_( 'SELECT DEPART DELETE', true ));
		}
		return $msg;
	}	
	
	/**
	 * get a departments for edit
	 * 
	 * (non-PHPdoc)
	 * @see libraries/joomla/application/component/JView#display($tpl)
	 */
	function getitem() {
		global $mainframe, $option;

		$db	=& JFactory::getDBO();
		$cid = JRequest::getVar( 'cid', array(), '', 'array' );
		JArrayHelper::toInteger($cid, array());		
		
		// array where[]
		$where = array();
		$where[] = " id  = '".$cid[0]."'";
		
		// build query 's where
		$where 		= ( count( $where ) ? ' WHERE ' . implode( ' AND ', $where ) : '' );		
		
		// get list of horse
		$sql = "SELECT * "
		."\n FROM `#__yj_contactus_departments` "
		."\n {$where}";
		$db->setQuery($sql);
		$rows = $db->loadObjectList();

		return $rows[0];
	}	
	
	/**
	 * publish or unpublish departments
	 *
	 * @param integer $state
	 * @return boolean
	 */
	function publish($state) {
		$cid = JRequest::getVar( 'cid', array(), '', 'array' );
		JArrayHelper::toInteger($cid, array());

		if (count($cid) > 0) {
			$row =& $this->getTable();
			foreach ($cid as $id) {
				$row->load($id);
				$row->published = $state;
				$row->store();

				if (!$row->check()) {
					$this->setError($row->getError());
					return false;
				}
				if (!$row->store()) {
					$this->setError($row->getError());
					return false;
				}
			}
		}
		return true;
	}
	
	/**
	 * Method order up(-1)/down(1) a department with one record
	 *
	 * $ordering = int current ordering value
	 * $uid		 = int moved category id
	 * $inc		 = int up(-1)/down(1)
	 *
	 * @access	public
	 * @return	boolean	True on success
	 */	
	function order(){
		global $mainframe;
		$db 	=& JFactory::getDBO();

		$cid	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		//generate move up or dowm
		$task = JRequest::getCmd('task');
		if ($task == 'orderup') {
			$direction = -1;
		} elseif ($task == 'orderdown') {
			$direction = +1;
		}else{
			$direction = $ordering;
		}
		
		if (isset( $cid[0] ))
		{
			$row = & $this->getTable();
			$row->load( (int) $cid[0] );
			$row->move($direction);

			$cache = & JFactory::getCache('com_yjcontactus');
			$cache->clean();
		}		

		$msg = JText::_('ORDERING SAVED');

		return $msg;
	}
	
	function saveOrder()
	{
		global $mainframe;

		// Initialize variables
		$db			= & JFactory::getDBO();

		$cid		= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$order		= JRequest::getVar( 'order', array (0), 'post', 'array' );
		$total		= count($cid);
		$conditions	= array ();

		JArrayHelper::toInteger($cid, array(0));
		JArrayHelper::toInteger($order, array(0));

		// Instantiate an article table object
		$row = & $this->getTable();

		// Update the ordering for items in the cid array
		for ($i = 0; $i < $total; $i ++)
		{
			$row->load( (int) $cid[$i] );
			if ($row->ordering != $order[$i]) {
				$row->ordering = $order[$i];
				if (!$row->store()) {
					JError::raiseError( 500, $db->getErrorMsg() );
					return false;
				}
			}
		}

		$cache = & JFactory::getCache('com_yjcontactus');
		$cache->clean();

		$msg = JText::_('ORDERING SAVED');
		return $msg;
	}
	

}
?>