<?php
/**
 * Default View for YjContactUS Component
 * 
 * @package    
 * @subpackage Components
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport( 'joomla.application.component.view' );

/**
 * Default View
 *
 * @package    
 * @subpackage Components
 */
class YjContactUSViewYjContactUS extends JView
{
	/**
	 * display method of YjContactUS view
	 * @return void
	 **/
	function display($tpl = null){
		JToolBarHelper::title( JText::_( 'TITLE FORM' ), 'generic.png' );
		JToolBarHelper::publishList();
		JToolBarHelper::unpublishList();
		JToolBarHelper::deleteList();
		JToolBarHelper::editListX();
		JToolBarHelper::addNewX();
		JToolBarHelper::preferences('com_yjcontactus', '200');
		
		// Get data from the model
		$return	= & $this->get( 'items');
		$this->assignRef('rows', $return['items']);
		$this->assignRef('pageNav', $return['pageNav']);
		$this->assignRef('lists', $return['lists']);
		
		parent::display($tpl);
	}
	
	/**
	 * add / edit a form
	 * 
	 * @param $tpl
	 * @return unknown_type
	 */
	function add($tpl = null) { 
		JToolBarHelper::title( JText::_( 'TITLE NEW FORM' ), 'generic.png' );
		JToolBarHelper::Save();
		JToolBarHelper::Apply();
		JToolBarHelper::Cancel();
		JToolBarHelper::preferences('com_yjcontactus', '200');		

		// Get departments 
		$departments = & $this->get( 'departments');
		$this->assignRef('departments', $departments);

		// Get menu items assign to yjcontactus
		$menu = & $this->get( 'menu');
		$this->assignRef('menu', $menu);		

		$this->setLayout('add');
		parent::display($tpl);
	}
	
	/**
	 * edit departments
	 *
	 */
	function edit($tpl = null) {
		JToolBarHelper::title(   JText::_( 'TITLE EDIT FORM' ), 'generic.png' );
		JToolBarHelper::Save();
		JToolBarHelper::Apply();		
		JToolBarHelper::Cancel();
		JToolBarHelper::preferences('com_yjcontactus', '200');		
		
		// Get departments 
		$departments = & $this->get( 'departments');		
		$this->assignRef('departments', $departments);		
		
		$item = $this->get('item');
		$this->assignRef('item', $item);

		//create new object to work selected values on multiple select
		$departments_array = explode(",",$item->departments);
		foreach($departments_array as $departments_row => $departments_value){
			$departments_selected[$departments_row]->value = $departments_value;
		}
		$this->assignRef('departments_selected', $departments_selected);

		// Get menu name assigned for this form
		$menu_name = & $this->get( 'menu_name' );
		$this->assignRef('menu_name', $menu_name);

		// Get menu type
		$menu = & $this->get( 'menu');
		$this->assignRef('menu', $menu);
		
		$this->setLayout('add');
		parent::display($tpl);
	}	
}
?>