<?php
/**
 * Departments View for YjContactUS Component
 * 
 * @package
 * @subpackage Components
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport( 'joomla.application.component.view' );

/**
 * Departments View
 *
 * @package
 * @subpackage Components
 */
class YjContactUSViewYjDepartments extends JView
{
	/**
	 * Departments view display method
	 * @return void
	 **/
	function display($tpl = null)
	{
		JToolBarHelper::title(   JText::_( 'TITLE DEPART' ), 'generic.png' );
		JToolBarHelper::publishList();
		JToolBarHelper::unpublishList();
		JToolBarHelper::deleteList();
		JToolBarHelper::editListX();
		JToolBarHelper::addNewX();
		JToolBarHelper::preferences('com_yjcontactus', '200');

		// Get data from the model
		$return	= & $this->get( 'items');
		$this->assignRef('rows', $return['items']);
		$this->assignRef('pageNav', $return['pageNav']);
		$this->assignRef('lists', $return['lists']);

		parent::display($tpl);
	}
	
	/**
	 * add / edit a department
	 * 
	 * @param $tpl
	 * @return unknown_type
	 */
	function add($tpl = null) { 
		JToolBarHelper::title(   JText::_( 'TITLE NEW DEPART' ), 'generic.png' );
		JToolBarHelper::Save();
		JToolBarHelper::Apply();		
		JToolBarHelper::Cancel();
		JToolBarHelper::preferences('com_yjcontactus', '200');		
			
		$this->setLayout('add');
		parent::display($tpl);
	}	
	
	/**
	 * edit departments
	 *
	 */
	function edit($tpl = null) {
		JToolBarHelper::title(   JText::_( 'TITLE EDIT DEPART' ), 'generic.png' );
		JToolBarHelper::Save();
		JToolBarHelper::Apply();		
		JToolBarHelper::Cancel();
		JToolBarHelper::preferences('com_yjcontactus', '200');		
		
		$item = $this->get('item');
		$this->assignRef('item', $item);

		$this->setLayout('add');
		parent::display($tpl);
	}	
}
?>